/***************************************************************************
 *            check_exists.c
 *
 *  Tue May 24 11:03:08 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#include "../include/remsync.h"

int
client_check_exists (int client_sd, char *src_dir, char *dest_dir, FILE * fd,
		     int port, char *servername)
{
	/* Scan through files in dest_dir to make sure that they still exist
	 * in src_dir - remove them if they don't - this could be dangerous!
	 */

	char message[BIG_BUF], command[BIG_BUF];
	char fulldest[BIG_BUF], fullsrc[BIG_BUF];
	int result, isdir;
	DIR *dir;
	struct dirent *d;

	/* Remember that dest_dir is the 'source' of this scan!
	 * Yes I know it's confusing!
	 */

	dir = opendir (dest_dir);

	while ((d = readdir (dir)))
	{
		if (strcmp (d->d_name, ".") != 0
		    && strcmp (d->d_name, "..") != 0)
		{
			bzero(command, BIG_BUF);
			/* Exclude . and .. */
			bzero(fulldest, BIG_BUF);
			bzero(fullsrc, BIG_BUF);
			sprintf (fulldest, "%s%s", dest_dir, d->d_name);

			/* fulldest now contains the full filename 
			 * Now we need to ask the server whether it has this file
			 * First we need to generate 'fullsrc' so that we know what to 
			 * ask for 
			 */

			sprintf (fullsrc, "%s%s", src_dir, d->d_name);

			isdir = is_a_dir (fulldest);
			if (conf.debug) printf("Check_exists: %s\n", fulldest);
			if (isdir == 1)
			{
				/* This is a directory, handle accordingly */
				/* First check whether this still exists on the server */
				bzero(command, BIG_BUF);
				sprintf (command, "exst:%s", fullsrc);
				if (conf.debug) printf("check_exists: isdir = 1, Sending command:\n%s\n", command);
				send (client_sd, command, strlen (command),
				      0);

				fgets (message, BIG_BUF, fd);
				strip_string (message);
				if (conf.debug) printf("Directory\n");
				
				if (strcmp (message, "YES") == 0)
				{
					/* this directory still exists on the server
					 * we now need to call ourselves again to scan this 
					 * directory - recursion at it's best ;-)
					 */
					checkslash(fullsrc);
					checkslash (fulldest);
					client_check_exists (client_sd,
							     fullsrc,
							     fulldest, fd,
							     port,
							     servername);
				}
				else
				{
					/* this has been deleted on the server - we need to 
					 * remove our copy (gulp)
					 */
					checkslash (fulldest);
					dirdelete (fulldest);
				}

			}
			else
			{
				/* An ordinary file - time to play ask the server */
				bzero(command,BIG_BUF);
				sprintf (command, "exst:%s", fullsrc);
				if (conf.debug) printf("check_exists: isdir != 1, Sending command:\n%s\n", command);
				send (client_sd, command, strlen (command),
				      0);

				fgets (message, BIG_BUF, fd);
				strip_string (message);
				if (strcmp (message, "YES") == 0)
				{
					if (conf.debug) printf ("File %s exists\n", fullsrc);
				}
				else
				{
					/* File doesn't exists on the server - we need to 
					 * remove our copy
					 */

					result = unlink (fulldest);
					if (conf.debug) printf ("File %s Deleted - Removing file %s\n",fullsrc, fulldest);
					if (result != 0)
					{
						printf ("Unlink failed %s\n",
							fulldest);
					}
				}
			}
		}
		
	}
	return 0;
}
